import { spawn } from "child_process";
import chokidar from "chokidar";
import chalk from "chalk";
import { getRootDirectory } from "../utils/get_root_dir_path.js";
import { readConfig } from "../utils/read_user_config_path.js";
import path, { join } from "path";
let fileExtension = "";
let indexFilePath = "";
export const startApp = () => {
    fileExtension = readConfig().language;
    indexFilePath = join(getRootDirectory(), `index.${fileExtension}`);
    const tsNodePath = path.join(__dirname, "node_modules", ".bin", "ts-node");
    const nodePath = path.join(__dirname, "node_modules", ".bin", "node");
    const child = spawn(fileExtension === "ts" ? tsNodePath : "node", [indexFilePath], { stdio: "inherit" });
    child.on("close", (code) => {
        if (code === 1) {
            console.log(chalk.bold(`${chalk.red("[DOLPH ERROR]: ")} ${chalk.redBright("exiting watch mode ...")}`));
            process.exit(1);
        }
    });
};
export const watchFile = () => {
    console.log(chalk.bold(`${chalk.green("[DOLPH INFO]: ")} ${chalk.greenBright("watching files for changes ...")}`));
    fileExtension = readConfig().language;
    const watcher = chokidar.watch(indexFilePath, {
        ignored: "/node_modules",
        persistent: true,
        ignoreInitial: false,
    });
    watcher.on("all", (_event, path) => {
        chalk.bold(`${chalk.green("[DOLPH INFO]: ")} ${chalk.greenBright("file changed" + `[${path}]`)}`);
        startApp();
    });
    process.on("SIGINT", () => {
        watcher.close();
        process.exit(0);
    });
};
// startApp();
// watchFile();
